﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Data.OleDb;

namespace WindowsFormsApp29
{
    public partial class Form1 : Form
    {
        OleDbDataAdapter da;
        DataSet ds;
        DataTable dt1;
        public Form1()
        {
            InitializeComponent();

            da = new OleDbDataAdapter("select * from radnik", @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\VETS\PABP\baza\PREDUZECE.mdb");

            OleDbCommandBuilder cb = new OleDbCommandBuilder(da);
            da.InsertCommand = cb.GetInsertCommand();
            da.UpdateCommand = cb.GetUpdateCommand();
            da.DeleteCommand = cb.GetDeleteCommand();


            ds = new DataSet();
            dt1 = new DataTable("Radnik");
        }

        private void btnUpdate_Click(object sender, EventArgs e)
        {
            try
            {
                int r = da.Update(dt1);
                MessageBox.Show("Uspesno promenjeno " + r + " redova");
            }
            catch(Exception ex)
            {
                if(MessageBox.Show("Dogodila se greška " + ex.Message + "Da li želite da ucitate nove podatke?") == DialogResult.OK)
                {
                    da.FillLoadOption = LoadOption.OverwriteChanges;
                    da.Fill(dt1);
                }
            }

        }

        private void button2_Click(object sender, EventArgs e)
        {
            //1. način
            //DataTable dtRez = dt1.Clone();
            //dataGridView1.DataSource = dtRez;

            //DataRow[] rows = dt1.Select("ime like '" + txtIme.Text + "%'");

            //foreach (DataRow row in rows)
            //{
            //    DataRow newrow = dtRez.NewRow();
            //    for (int i = 0; i < dt1.Columns.Count; i++)
            //        newrow[i] = row[i];
            //    dtRez.Rows.Add(newrow);
            //}



            // 2. način
            DataTable dtRez = new DataTable();
            IEnumerable<DataRow> rows = dt1.Rows.Cast<DataRow>();
            IEnumerable<DataRow> rez = rows.Where(x => ((string)x["ime"]).StartsWith(txtFilterIme.Text));

            if (rez.Count() > 0)
            {
                dt1 = rez.CopyToDataTable();
                dataGridView1.DataSource = dt1;
            }
                
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            ds.Tables.Add(dt1);

            if(ds.HasChanges())
            {
                if(MessageBox.Show("Da li odbacujete promene?", "Upozorenje", MessageBoxButtons.YesNo, MessageBoxIcon.Question)== DialogResult.Yes)
                {
                    ds.RejectChanges();
                }
            }
        }

        private void btnNoviRadnik_Click(object sender, EventArgs e)
        {
            FrmNoviRadnik f = new FrmNoviRadnik(dt1, da);
            f.Show();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // ako se pri punjenju prebacuju podaci o kljucu
            da.MissingSchemaAction = MissingSchemaAction.AddWithKey;

            da.Fill(dt1);

            // Povezivanje dgv kontrole
            dataGridView1.DataSource = dt1;

            // povezivanje koristeci DataSource i DataMember svojstva
            //da.Fill(ds);
            //dataGridView1.DataSource = ds;
            //dataGridView1.DataMember = ds.Tables[0].TableName;


            // PRIMERI POVEZIVANJA ostalih kontrola
            // cb i lb
            listBox1.DataSource = dt1;
            listBox1.DisplayMember = "ime";

            comboBox1.DataSource = dt1;
            comboBox1.DisplayMember = "ime";

            // povezivanje sa jednostavnim kontrolama
            txtIme.DataBindings.Add("Text", dt1, "ime");
            dtpDatumZap.DataBindings.Add("Value", dt1, "datzap");
            progressBar1.DataBindings.Add("Value", dt1, "plata");
        }
    }
}
